## openmesh 11.0.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.10.0 FATAL_ERROR)


# Set and enforce C++-11 flags
#set( CMAKE_CXX_STANDARD_REQUIRED TRUE )
#set( CMAKE_CXX_STANDARD 11 )

enable_testing()


project (OpenMesh 
         VERSION 11.0.0
         LANGUAGES C CXX ) 

# Set AUTO UIC/MOC Policy to new for CMAKE 3.17 or higher
if(${CMAKE_VERSION} VERSION_GREATER_EQUAL "3.17")
    cmake_policy(SET CMP0100 NEW)
endif()


if(CMAKE_CXX_COMPILER_ID STREQUAL "GNU")
	if(CMAKE_CXX_COMPILER_VERSION VERSION_LESS "6.0" AND CMAKE_CXX_COMPILER_VERSION VERSION_GREATER "4.9" OR CMAKE_CXX_COMPILER_VERSION VERSION_EQUAL "4.9")
		message(WARNING "Your version of GCC contains an optimizer bug. Please verify that you do not use -O3!")
		string(REPLACE "-O3" "-O2" CMAKE_CXX_FLAGS_RELEASE_NEW "${CMAKE_CXX_FLAGS_RELEASE}")
		set(CMAKE_CXX_FLAGS_RELEASE "${CMAKE_CXX_FLAGS_RELEASE_NEW}" CACHE STRING "" FORCE)
	endif()
endif()

if ( WIN32 )
  # This is the base directory for windows library search used in the finders we ship.
  set(CMAKE_WINDOWS_LIBS_DIR "c:/libs" CACHE STRING "Default Library search dir on windows." )
endif()

if (NOT WIN32 AND NOT CMAKE_BUILD_TYPE)
  message(STATUS "No build type selected, default to Release")
  set(CMAKE_BUILD_TYPE "Release" CACHE STRING "Choose the type of build, options are: Debug Release RelWithDebInfo MinSizeRel." FORCE)
endif()

# add our macro directory to cmake search path
set (CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${CMAKE_SOURCE_DIR}/cmake ${CMAKE_CURRENT_SOURCE_DIR}/cmake ${CMAKE_CURRENT_SOURCE_DIR}/cmake-library/finders ${CMAKE_CURRENT_SOURCE_DIR}/cmake-library/VCI )
set (CMAKE_DEBUG_POSTFIX "d")

# include our cmake files
include (VCICommon)

# Disable package building when built as an external library
if(${CMAKE_PROJECT_NAME} MATCHES "OpenMesh")
    include(OpenMeshPackage)
endif()

include (VCIOutput)
include(VCIQt)

# ========================================================================
# Definitions
# ========================================================================

if (WIN32)
  add_definitions(
      -D_USE_MATH_DEFINES -DNOMINMAX
      -D_CRT_SECURE_NO_WARNINGS
  )
endif ()

set(NO_DECREMENT_DEPRECATED_WARNINGS OFF CACHE BOOL "Disables all deprecated warnings warning about decrement operations on normal circulators.")
if(NO_DECREMENT_DEPRECATED_WARNINGS)
  add_definitions( -DNO_DECREMENT_DEPRECATED_WARNINGS )
endif()

# ========================================================================
# Windows build style control
# ========================================================================

if ( WIN32 )
  if ( NOT DEFINED OPENMESH_BUILD_SHARED )
    set( OPENMESH_BUILD_SHARED false CACHE BOOL "Build as shared library(DLL)?" )
  endif()
endif()

# ========================================================================
# Add bundle targets here
# ========================================================================
if ( NOT DEFINED BUILD_APPS )
  set( BUILD_APPS true CACHE BOOL "Enable or disable building of apps" )
endif()

# Only call fixbundle, when we are building OpenMesh standalone
if( (${CMAKE_PROJECT_NAME} MATCHES "OpenMesh") AND BUILD_APPS )

  if (WIN32)
    if ( NOT "${CMAKE_GENERATOR}" MATCHES "MinGW Makefiles" AND BUILD_APPS )
      add_custom_target (fixbundle ALL
        COMMAND ${CMAKE_COMMAND} -P "${CMAKE_BINARY_DIR}/fixbundle.win.cmake" )
    endif()
  endif()

  if (APPLE)
    add_custom_target (fixbundle ALL
      COMMAND ${CMAKE_COMMAND} -P "${CMAKE_BINARY_DIR}/fixbundle.cmake"
    )
  endif()

endif() # project OpenMesh

# ========================================================================
# Call the subdirectories with there projects
# ========================================================================

add_subdirectory (src/OpenMesh/Core)
add_subdirectory (src/OpenMesh/Tools)
add_subdirectory (src/OpenMesh/Apps)

set(OPENMESH_BENCHMARK_DIR CACHE PATH "Source path of benchmark (https://github.com/google/benchmark).")
if (OPENMESH_BENCHMARK_DIR)
	add_subdirectory(${OPENMESH_BENCHMARK_DIR} benchmark)
	add_subdirectory(src/Benchmark)
endif()

# Do not build unit tests when build as external library
if(${CMAKE_PROJECT_NAME} MATCHES "OpenMesh")
    add_subdirectory (src/Unittests)
else()
	# If built as a dependent project simulate effects of
	# successful finder run:
	set (OPENMESH_FOUND true PARENT_SCOPE)
	set (OPENMESH_LIBRARIES OpenMeshCore OpenMeshTools PARENT_SCOPE)
	set (OPENMESH_INCLUDE_DIR  "${CMAKE_CURRENT_SOURCE_DIR}/src" PARENT_SCOPE)
	set (OPENMESH_INCLUDE_DIRS "${CMAKE_CURRENT_SOURCE_DIR}/src" PARENT_SCOPE)

	# Also define variables provided by the old legacy finder.
	set (OPENMESH_CORE_LIBRARY OpenMeshCore PARENT_SCOPE)
	set (OPENMESH_TOOLS_LIBRARY OpenMeshTools PARENT_SCOPE)
	set (OPENMESH_TOOLS_LIBRARY OpenMeshTools PARENT_SCOPE)
	set (OPENMESH_LIBRARY OpenMeshCore OpenMeshTools PARENT_SCOPE)
	get_target_property(_OPENMESH_LIBRARY_DIR OpenMeshCore LIBRARY_OUTPUT_DIRECTORY)
	set (OPENMESH_LIBRARY_DIR "${_OPENMESH_LIBRARY_DIR}" CACHE PATH "The directory where the OpenMesh libraries can be found.")
endif()

if ( NOT DEFINED OPENMESH_DOCS )
  set( OPENMESH_DOCS true CACHE BOOL "Enable or disable building of documentation" )
endif()

if (OPENMESH_DOCS)
  add_subdirectory (Doc)
endif()

# ========================================================================
# Bundle generation (Targets exist, now configure them)
# ========================================================================

# Only call fixbundle, when we are building OpenMesh standalone
if(${CMAKE_PROJECT_NAME} MATCHES "OpenMesh")

  if (WIN32 AND  BUILD_APPS)
    # prepare bundle generation cmake file and add a build target for it
    configure_file ("${CMAKE_CURRENT_SOURCE_DIR}/cmake/fixbundle.cmake.win.in"
       "${CMAKE_CURRENT_BINARY_DIR}/fixbundle.win.cmake" @ONLY IMMEDIATE)

    if ( NOT "${CMAKE_GENERATOR}" MATCHES "MinGW Makefiles" )
      # let bundle generation depend on all targets
      add_dependencies (fixbundle QtViewer DecimaterGui)
    endif()
 
  endif()
 
  # On apple we do a fixbundle, which is only necessary for the apps and not for the libs
  if (APPLE AND BUILD_APPS)
    # prepare bundle generation cmake file and add a build target for it
    configure_file ("${CMAKE_SOURCE_DIR}/cmake/fixbundle.cmake.in"
       "${CMAKE_BINARY_DIR}/fixbundle.cmake" @ONLY IMMEDIATE)

    # let bundle generation depend on all targets
    if (QT_FOUND)
        add_dependencies (fixbundle DecimaterGui ProgViewer QtViewer SubdividerGui)
    endif()

    # Required for Snow leopard, and the latest qt. Then the resources have to be copied
    if ( EXISTS "/opt/local/libexec/qt4-mac/lib/QtGui.framework/Versions/4/Resources/qt_menu.nib" )
        add_custom_command(TARGET OpenMesh POST_BUILD
           COMMAND ${CMAKE_COMMAND} -E copy_directory "/opt/local/libexec/qt4-mac/lib/QtGui.framework/Versions/4/Resources/qt_menu.nib" 
                                                      "${CMAKE_BINARY_DIR}/Build/Libraries/qt_menu.nib" )
    endif ()
  endif ()

endif()

# ========================================================================

# Generate openmesh.pc file

set(DEST_DIR "${CMAKE_INSTALL_PREFIX}")
set(PRIVATE_LIBS "-lOpenMeshCore -lOpenMeshTools")

configure_file("openmesh.pc.in" "${CMAKE_CURRENT_BINARY_DIR}/openmesh.pc" @ONLY)

install(FILES ${CMAKE_CURRENT_BINARY_DIR}/openmesh.pc DESTINATION libdata/pkgconfig)

# generate target file

install(EXPORT OpenMeshConfig DESTINATION share/OpenMesh/cmake)

export(TARGETS OpenMeshCore OpenMeshTools FILE OpenMeshConfig.cmake)

# display results
vci_print_configure_header (OPENMESH "OpenMesh")

=== cmake-library/CI/CMakeLists.txt ===
# This CMakeLists only does find_package to test our finders.
# We might want to enable some calls based on what is actually installed on the CI runner.


cmake_minimum_required(VERSION 3.13 FATAL_ERROR)
project(CMakeLibraryCITest)


list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/../finders")

find_package(GMM)
find_package(Gurobi)
find_package(Mosek)


enable_testing()
add_subdirectory(tests)

=== src/Unittests/CMakeLists.txt ===
include(VCICommon)

set(UNITTEST_SRC
  unittests.cc
  unittests_add_face.cc
  unittests_boundary.cc
  unittests_centroid_calculations.cc
  unittests_convert_meshes.cc
  unittests_cpp_11_features.cc
  unittests_decimater.cc
  unittests_delete_face.cc
  unittests_eigen3_type.cc
  unittests_faceless_mesh.cc
  unittests_holefiller.cc
  unittests_mc_decimater.cc
  unittests_mesh_cast.cc
  unittests_mesh_dual.cc
  unittests_mesh_type.cc
  unittests_mixed_decimater.cc
  unittests_new_vertex.cc
  unittests_normal_calculations.cc
  unittests_polymesh_collapse.cc
  unittests_polymesh_vec2i.cc
  unittests_property.cc
  unittests_propertymanager.cc
  unittests_randomNumberGenerator.cc
  unittests_read_write_OBJ.cc
  unittests_read_write_OFF.cc
  unittests_read_write_OM.cc
  unittests_read_write_PLY.cc
  unittests_read_write_STL.cc
  unittests_set_positions_directly.cc
  unittests_smart_handles.cc
  unittests_smart_ranges.cc
  unittests_smarttagger.cc
  unittests_smoother.cc
  unittests_split_copy.cc
  unittests_split_edge_copy.cc
  unittests_sr_binary.cc
  unittests_stripifier.cc
  unittests_subdivider_adaptive.cc
  unittests_subdivider_uniform.cc
  unittests_traits.cc
  unittests_trimesh_circulator_current_halfedge_handle_replacement.cc
  unittests_trimesh_circulator_edge_face.cc
  unittests_trimesh_circulator_edge_halfedge.cc
  unittests_trimesh_circulator_edge_vertex.cc
  unittests_trimesh_circulator_face_edge.cc
  unittests_trimesh_circulator_face_face.cc
  unittests_trimesh_circulator_face_halfedge.cc
  unittests_trimesh_circulator_face_vertex.cc
  unittests_trimesh_circulator_halfedge_loop.cc
  unittests_trimesh_circulator_vertex_edge.cc
  unittests_trimesh_circulator_vertex_face.cc
  unittests_trimesh_circulator_vertex_ihalfedge.cc
  unittests_trimesh_circulator_vertex_ohalfedge.cc
  unittests_trimesh_circulator_vertex_vertex.cc
  unittests_trimesh_collapse.cc
  unittests_trimesh_garbage_collection.cc
  unittests_trimesh_iterators.cc
  unittests_trimesh_navigation.cc
  unittests_trimesh_others.cc
  unittests_trimesh_ranges.cc
  unittests_trimesh_split.cc
  unittests_trimesh_vec2i.cc
  unittests_tutorials.cc
  unittests_vdpm.cc
  unittests_vector_type.cc
)

if (NOT DEFINED OPENMESH_BUILD_UNIT_TESTS)
  set(OPENMESH_BUILD_UNIT_TESTS false CACHE BOOL "Enable or disable unit test builds in OpenMesh.")
endif()

if (OPENMESH_BUILD_UNIT_TESTS)
  # Fetch Gtest from github
  include(FetchContent)
  FetchContent_Declare(
    googletest
    GIT_REPOSITORY https://github.com/google/googletest.git
    GIT_TAG f8d7d77c06936315286eb55f8de22cd23c188571 # v1.14.0
    #FIND_PACKAGE_ARGS NAMES GTest
  )
  # For Windows: Prevent overriding the parent project's compiler/linker settings
  set(gtest_force_shared_crt ON CACHE BOOL "" FORCE)
  FetchContent_MakeAvailable(googletest)

  enable_testing()

  find_package(Eigen3)

  # Set correct include paths so that the compiler can find the headers
  include_directories(${GTEST_INCLUDE_DIRS})

  # Set additional link directories
  link_directories(${GTEST_LIBRARY_DIR})

  if (TARGET Eigen3::Eigen)
    add_definitions(-DENABLE_EIGEN3_TEST)
    link_libraries(Eigen3::Eigen)
  else()
    message(WARNING "Eigen3 not found! This will skip the Eigen3 Unittests. You can point cmake to Eigen3 by setting Eigen3_DIR to the cmake files of Eigen3")
  endif()

  # Create new target named unittests_hexmeshing
  # Create unittest executable
  vci_add_executable(unittests ${UNITTEST_SRC})
  vci_add_executable(unittests_customvec ${UNITTEST_SRC})
  vci_add_executable(unittests_doublevec ${UNITTEST_SRC})
  target_compile_definitions(unittests_customvec PRIVATE TEST_CUSTOM_TRAITS)
  target_compile_definitions(unittests_doublevec PRIVATE TEST_DOUBLE_TRAITS)

  # For the unittest we don't want the install rpath as set by vci_add_executable
  set_target_properties(unittests PROPERTIES BUILD_WITH_INSTALL_RPATH 0)
  set_target_properties(unittests_customvec PROPERTIES BUILD_WITH_INSTALL_RPATH 0)
  set_target_properties(unittests_doublevec PROPERTIES BUILD_WITH_INSTALL_RPATH 0)

  # Set output directory to ${BINARY_DIR}/Unittests
  set(OUTPUT_DIR "${CMAKE_BINARY_DIR}/Unittests")
  set_target_properties(unittests PROPERTIES RUNTIME_OUTPUT_DIRECTORY ${OUTPUT_DIR})
  set_target_properties(unittests_customvec PROPERTIES RUNTIME_OUTPUT_DIRECTORY ${OUTPUT_DIR})
  set_target_properties(unittests_doublevec PROPERTIES RUNTIME_OUTPUT_DIRECTORY ${OUTPUT_DIR})
  foreach (CONFIG ${CMAKE_CONFIGURATION_TYPES})
    string(TOUPPER ${CONFIG} UPCONFIG)
    set_target_properties(unittests PROPERTIES RUNTIME_OUTPUT_DIRECTORY_${UPCONFIG} ${OUTPUT_DIR})
    set_target_properties(unittests_customvec PROPERTIES RUNTIME_OUTPUT_DIRECTORY_${UPCONFIG} ${OUTPUT_DIR})
    set_target_properties(unittests_doublevec PROPERTIES RUNTIME_OUTPUT_DIRECTORY_${UPCONFIG} ${OUTPUT_DIR})
  endforeach ()

  if (NOT WIN32)
    # Link against all necessary libraries
    target_link_libraries(unittests OpenMeshCore OpenMeshTools GTest::gtest GTest::gtest_main pthread)
    target_link_libraries(unittests_customvec OpenMeshCore OpenMeshTools GTest::gtest GTest::gtest_main pthread)
    target_link_libraries(unittests_doublevec OpenMeshCore OpenMeshTools GTest::gtest GTest::gtest_main pthread)
  else()
    # Link against all necessary libraries
    target_link_libraries(unittests OpenMeshCore OpenMeshTools GTest::gtest GTest::gtest_main)
    target_link_libraries(unittests_customvec OpenMeshCore OpenMeshTools GTest::gtest GTest::gtest_main)
    target_link_libraries(unittests_doublevec OpenMeshCore OpenMeshTools GTest::gtest GTest::gtest_main)

    if (OPENMESH_BUILD_SHARED)
      add_definitions(-DOPENMESHDLL)
    endif()
  endif()

  if (NOT WIN32)
    # Set compiler flags
    set_target_properties(unittests PROPERTIES COMPILE_FLAGS "-g -pedantic -Wno-long-long")
    set_target_properties(unittests_customvec PROPERTIES COMPILE_FLAGS "-g -pedantic -Wno-long-long")
    set_target_properties(unittests_doublevec PROPERTIES COMPILE_FLAGS "-g -pedantic -Wno-long-long")
  else()
    # Set compiler flags
    set_target_properties(unittests PROPERTIES COMPILE_FLAGS "")
    set_target_properties(unittests_customvec PROPERTIES COMPILE_FLAGS "")
    set_target_properties(unittests_doublevec PROPERTIES COMPILE_FLAGS "")
  endif()

  if (OPENMESH_BUILD_SHARED)
    # Copy dlls to unittests
    SET(OPENMESH_TARGETS "OpenMeshTools" "OpenMeshCore")

    foreach (TAR ${OPENMESH_TARGETS})
      add_custom_command(TARGET unittests POST_BUILD
        COMMAND "${CMAKE_COMMAND}" -E copy
        "$<TARGET_FILE:${TAR}>"
        "${CMAKE_BINARY_DIR}/Unittests/$<TARGET_FILE_NAME:${TAR}>"
        COMMENT "Copying OpenMesh targets to unittests directory")
      add_custom_command(TARGET unittests_customvec POST_BUILD
        COMMAND "${CMAKE_COMMAND}" -E copy
        "$<TARGET_FILE:${TAR}>"
        "${CMAKE_BINARY_DIR}/Unittests/$<TARGET_FILE_NAME:${TAR}>"
        COMMENT "Copying OpenMesh targets to unittests directory")
      add_custom_command(TARGET unittests_doublevec POST_BUILD
        COMMAND "${CMAKE_COMMAND}" -E copy
        "$<TARGET_FILE:${TAR}>"
        "${CMAKE_BINARY_DIR}/Unittests/$<TARGET_FILE_NAME:${TAR}>"
        COMMENT "Copying OpenMesh targets to unittests directory")
    endforeach (TAR)
  endif()

  vci_copy_after_build(unittests ${CMAKE_CURRENT_SOURCE_DIR}/TestFiles ${CMAKE_BINARY_DIR}/Unittests/)
  vci_copy_after_build(unittests_customvec ${CMAKE_CURRENT_SOURCE_DIR}/TestFiles ${CMAKE_BINARY_DIR}/Unittests/)
  vci_copy_after_build(unittests_doublevec ${CMAKE_CURRENT_SOURCE_DIR}/TestFiles ${CMAKE_BINARY_DIR}/Unittests/)

  add_test(NAME AllTestsIn_OpenMesh_tests WORKING_DIRECTORY "${CMAKE_BINARY_DIR}/Unittests" COMMAND "${CMAKE_BINARY_DIR}/Unittests/unittests")
  add_test(NAME AllTestsIn_OpenMesh_tests_with_minimal_vector WORKING_DIRECTORY "${CMAKE_BINARY_DIR}/Unittests" COMMAND "${CMAKE_BINARY_DIR}/Unittests/unittests_customvec")
  add_test(NAME AllTestsIn_OpenMesh_tests_with_double_vector WORKING_DIRECTORY "${CMAKE_BINARY_DIR}/Unittests" COMMAND "${CMAKE_BINARY_DIR}/Unittests/unittests_doublevec")
endif()

=== src/OpenMesh/Apps/CMakeLists.txt ===
include (VCICommon)

if ( NOT DEFINED BUILD_APPS )
  set( BUILD_APPS true CACHE BOOL "Enable or disable building of apps" )
endif()
 
if ( BUILD_APPS )

  # Only build and fixbundle apps, when we are building OpenMesh standalone
  if(${CMAKE_PROJECT_NAME} MATCHES "OpenMesh")

    if ( WIN32 AND OPENMESH_BUILD_SHARED )
	  add_definitions(-DOPENMESHDLL )
    endif()

    add_subdirectory (Dualizer)
    add_subdirectory (Decimating/commandlineDecimater)
    add_subdirectory (Smoothing)
    add_subdirectory (Subdivider/commandlineSubdivider)
    add_subdirectory (Subdivider/commandlineAdaptiveSubdivider)
    add_subdirectory (mconvert)
    add_subdirectory (VDProgMesh/mkbalancedpm)
    add_subdirectory (VDProgMesh/Analyzer)

    # Add non ui apps as dependency before fixbundle 
    if ( APPLE OR (WIN32 AND NOT "${CMAKE_GENERATOR}" MATCHES "MinGW Makefiles" ) )
        # let bundle generation depend on all targets
	add_dependencies (fixbundle commandlineDecimater Dualizer mconvert Smoothing commandlineAdaptiveSubdivider commandlineSubdivider mkbalancedpm Analyzer )
    endif()

    set( OpenGL_GL_PREFERENCE GLVND)

    # find needed packages for gui applications
    find_package (OpenGL)

    # For the apps, we need qt and opengl to build them
    if (NOT QT_FOUND)
      set(QT_REQUIRED_PACKAGES
        Core
        Widgets
        OpenGL
        Gui
        )
      set(QT6_REQUIRED_PACKAGES
        OpenGLWidgets
        )
      vci_qt ()
      set(CMAKE_AUTOMOC ON)
    endif()

    if ("${CMAKE_GENERATOR}" MATCHES "MinGW Makefiles")
      message(WARNING "GUI Apps are not build with mingw. (TODO)")
    endif()

    # check for OpenGL as our required dependencies
    if (( QT_FOUND ) AND OPENGL_FOUND AND NOT "${CMAKE_GENERATOR}" MATCHES "MinGW Makefiles" )

      add_subdirectory (Decimating/DecimaterGui)
      add_subdirectory (QtViewer)
      add_subdirectory (Subdivider/SubdividerGui)
      add_subdirectory (ProgViewer)
      add_subdirectory (VDProgMesh/Synthesizer)
			    

      # Add ui apps as dependency before fixbundle 
      # Required on Windows (NOTMINGW) and APPLE
      if ( APPLE OR (WIN32 AND NOT "${CMAKE_GENERATOR}" MATCHES "MinGW Makefiles") )
	# let bundle generation depend on all targets
	add_dependencies (fixbundle DecimaterGui ProgViewer QtViewer SubdividerGui Synthesizer)
      endif()
    
      if ( WIN32 )
	    FILE(GLOB files_install_app_dlls "${CMAKE_BINARY_DIR}/Build/*.dll" )
	    INSTALL(FILES ${files_install_app_dlls} DESTINATION . )

            # platform plugins for qt shoulb be installed along with the apps to run on the target systems
            if (EXISTS ${CMAKE_BINARY_DIR}/Build/plugins/platforms )
              FILE(GLOB files_install_app_platform_dlls "${CMAKE_BINARY_DIR}/Build/plugins/platforms/*.dll" )
              INSTALL(FILES ${files_install_app_platform_dlls} DESTINATION plugins/platforms/ )

              # Create a qt.conf file to find plugins on windows
              INSTALL(FILES ${CMAKE_CURRENT_SOURCE_DIR}/Qt/qt.conf DESTINATION . )
            endif()

      endif()

    else () # QT ,Opengl or glut not found
      
      if (NOT QT_FOUND)
	    message ("QT not found! Skipping some apps.")
      endif ()

      if (NOT OPENGL_FOUND)
	    message ("OpengGL not found! Skipping some apps.")
      endif ()

    endif ()

  endif() # Project is OpenMesh standalone

else (BUILD_APPS)

  message ("Building Apps disabled by user.")

endif (BUILD_APPS)

=== src/OpenMesh/Core/CMakeLists.txt ===
include (VCICommon)

set ( headers
Geometry/Config.hh
Geometry/EigenVectorT.hh
Geometry/LoopSchemeMaskT.hh
Geometry/MathDefs.hh
Geometry/NormalConeT.hh
Geometry/NormalConeT_impl.hh
Geometry/Plane3d.hh
Geometry/QuadricT.hh
Geometry/Vector11T.hh
Geometry/VectorT.hh
Geometry/VectorT_inc.hh
IO/BinaryHelper.hh
IO/IOInstances.hh
IO/IOManager.hh
IO/MeshIO.hh
IO/OFFFormat.hh
IO/OMFormat.hh
IO/OMFormatT_impl.hh
IO/Options.hh
IO/SR_binary.hh
IO/SR_binary_spec.hh
IO/SR_binary_vector_of_bool.hh 
IO/SR_rbo.hh
IO/SR_store.hh
IO/SR_types.hh
IO/StoreRestore.hh
IO/exporter/BaseExporter.hh
IO/exporter/ExporterT.hh
IO/importer/BaseImporter.hh
IO/importer/ImporterT.hh
IO/reader/BaseReader.hh
IO/reader/OBJReader.hh
IO/reader/OFFReader.hh
IO/reader/OMReader.hh
IO/reader/PLYReader.hh
IO/reader/STLReader.hh
IO/writer/BaseWriter.hh
IO/writer/OBJWriter.hh
IO/writer/OFFWriter.hh
IO/writer/OMWriter.hh
IO/writer/PLYWriter.hh
IO/writer/STLWriter.hh
IO/writer/VTKWriter.hh
Mesh/ArrayItems.hh
Mesh/ArrayKernel.hh
Mesh/ArrayKernelT_impl.hh
Mesh/AttribKernelT.hh
Mesh/Attributes.hh
Mesh/BaseKernel.hh
Mesh/BaseMesh.hh
Mesh/Casts.hh
Mesh/CirculatorsT.hh
Mesh/DefaultPolyMesh.hh
Mesh/DefaultTriMesh.hh
Mesh/FinalMeshItemsT.hh
Mesh/Handles.hh
Mesh/IteratorsT.hh
Mesh/PolyConnectivity.hh
Mesh/PolyConnectivity_inline_impl.hh
Mesh/PolyMeshT.hh
Mesh/PolyMeshT_impl.hh
Mesh/PolyMesh_ArrayKernelT.hh
Mesh/SmartHandles.hh
Mesh/SmartRange.hh
Mesh/Status.hh
Mesh/Tags.hh
Mesh/Traits.hh
Mesh/TriConnectivity.hh
Mesh/TriMeshT.hh
Mesh/TriMeshT_impl.hh
Mesh/TriMesh_ArrayKernelT.hh
Mesh/gen/circulators_header.hh
Mesh/gen/circulators_template.hh
Mesh/gen/footer.hh
Mesh/gen/iterators_header.hh
Mesh/gen/iterators_template.hh
System/OpenMeshDLLMacros.hh
System/compiler.hh
System/config.hh
System/mostream.hh
System/omstream.hh
Utils/AutoPropertyHandleT.hh
Utils/BaseProperty.hh
Utils/Endian.hh
Utils/GenProg.hh
Utils/HandleToPropHandle.hh
Utils/Noncopyable.hh
Utils/Predicates.hh
Utils/Property.hh
Utils/PropertyContainer.hh
Utils/PropertyCreator.hh
Utils/PropertyManager.hh
Utils/RandomNumberGenerator.hh
Utils/SingletonT.hh
Utils/SingletonT_impl.hh
Utils/color_cast.hh
Utils/typename.hh
Utils/vector_cast.hh
Utils/vector_traits.hh
)

set ( sources
IO/BinaryHelper.cc
IO/IOManager.cc
IO/OMFormat.cc
IO/reader/BaseReader.cc
IO/reader/OBJReader.cc
IO/reader/OFFReader.cc
IO/reader/OMReader.cc
IO/reader/PLYReader.cc
IO/reader/STLReader.cc
IO/writer/BaseWriter.cc
IO/writer/OBJWriter.cc
IO/writer/OFFWriter.cc
IO/writer/OMWriter.cc
IO/writer/PLYWriter.cc
IO/writer/STLWriter.cc
IO/writer/VTKWriter.cc
Mesh/ArrayKernel.cc
Mesh/BaseKernel.cc
Mesh/PolyConnectivity.cc
Mesh/TriConnectivity.cc
System/omstream.cc
Utils/BaseProperty.cc
Utils/Endian.cc
Utils/PropertyCreator.cc
Utils/RandomNumberGenerator.cc
)

# Disable Library installation when not building OpenMesh on its own but as part of another project!
if ( NOT ${CMAKE_PROJECT_NAME} MATCHES "OpenMesh")
  set(VCI_NO_LIBRARY_INSTALL true)
endif()


if (WIN32)

  if ( OPENMESH_BUILD_SHARED )
    add_definitions( -DOPENMESHDLL -DBUILDOPENMESHDLL)
    vci_add_library (OpenMeshCore SHARED ${sources} ${headers})
  else()
    vci_add_library (OpenMeshCore STATIC ${sources} ${headers})
  endif()

  target_include_directories(OpenMeshCore PUBLIC
                                        $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/../..>
                                        $<INSTALL_INTERFACE:include>)


else ()
  vci_add_library (OpenMeshCore SHAREDANDSTATIC ${sources} ${headers})

  target_include_directories(OpenMeshCore PUBLIC
                                          $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/../..>
                                          $<INSTALL_INTERFACE:include>)

  target_include_directories(OpenMeshCoreStatic PUBLIC
                                          $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/../..>
                                          $<INSTALL_INTERFACE:include>)

  set_target_properties (OpenMeshCore PROPERTIES VERSION ${PROJECT_VERSION_MAJOR}.${PROJECT_VERSION_MINOR}
                                               SOVERSION ${PROJECT_VERSION_MAJOR}.${PROJECT_VERSION_MINOR} )
endif ()

if (MSVC)
  target_compile_options(OpenMeshCore PUBLIC /bigobj)
endif ()

# Add core as dependency before fixbundle 
if ( (${CMAKE_PROJECT_NAME} MATCHES "OpenMesh") AND BUILD_APPS )

  if ( APPLE OR (WIN32 AND NOT "${CMAKE_GENERATOR}" MATCHES "MinGW Makefiles" ) )
      add_dependencies (fixbundle OpenMeshCore)
  endif()

endif()

# if we build debug and release in the same dir, we want to install both!
if ( ${CMAKE_PROJECT_NAME} MATCHES "OpenMesh")
  if ( WIN32 )
    FILE(GLOB files_install_libs "${CMAKE_BINARY_DIR}/Build/lib/*.lib" )
    FILE(GLOB files_install_dlls "${CMAKE_BINARY_DIR}/Build/*.dll" )
    INSTALL(FILES ${files_install_libs} DESTINATION lib )
    INSTALL(FILES ${files_install_dlls} DESTINATION . )
  endif()
endif()


# Install Header Files (Apple)
if ( NOT VCI_PROJECT_MACOS_BUNDLE AND APPLE )
 FILE(GLOB files_install_Geometry    "${CMAKE_CURRENT_SOURCE_DIR}/Geometry/*.hh" )
 FILE(GLOB files_install_IO          "${CMAKE_CURRENT_SOURCE_DIR}/IO/*.hh" "${CMAKE_CURRENT_SOURCE_DIR}/IO/*.inl"  )
 FILE(GLOB files_install_IO_importer "${CMAKE_CURRENT_SOURCE_DIR}/IO/importer/*.hh" )
 FILE(GLOB files_install_IO_exporter "${CMAKE_CURRENT_SOURCE_DIR}/IO/exporter/*.hh" )
 FILE(GLOB files_install_IO_reader   "${CMAKE_CURRENT_SOURCE_DIR}/IO/reader/*.hh" )
 FILE(GLOB files_install_IO_writer   "${CMAKE_CURRENT_SOURCE_DIR}/IO/writer/*.hh" )
 FILE(GLOB files_install_Mesh        "${CMAKE_CURRENT_SOURCE_DIR}/Mesh/*.hh" )
 FILE(GLOB files_install_Mesh_Gen    "${CMAKE_CURRENT_SOURCE_DIR}/Mesh/gen/*.hh" )
 FILE(GLOB files_install_System      "${CMAKE_CURRENT_SOURCE_DIR}/System/*.hh" "${CMAKE_CURRENT_SOURCE_DIR}/System/config.h" )
 FILE(GLOB files_install_Utils       "${CMAKE_CURRENT_SOURCE_DIR}/Utils/*.hh" )
 INSTALL(FILES ${files_install_Geometry}    DESTINATION include/OpenMesh/Core/Geometry )
 INSTALL(FILES ${files_install_IO}          DESTINATION include/OpenMesh/Core/IO )
 INSTALL(FILES ${files_install_IO_importer} DESTINATION include/OpenMesh/Core/IO/importer )
 INSTALL(FILES ${files_install_IO_exporter} DESTINATION include/OpenMesh/Core/IO/exporter )
 INSTALL(FILES ${files_install_IO_reader}   DESTINATION include/OpenMesh/Core/IO/reader )
 INSTALL(FILES ${files_install_IO_writer}   DESTINATION include/OpenMesh/Core/IO/writer )
 INSTALL(FILES ${files_install_Mesh}        DESTINATION include/OpenMesh/Core/Mesh )
 INSTALL(FILES ${files_install_Mesh_Gen}    DESTINATION include/OpenMesh/Core/Mesh/gen )
 INSTALL(FILES ${files_install_System}      DESTINATION include/OpenMesh/Core/System )
 INSTALL(FILES ${files_install_Utils}       DESTINATION include/OpenMesh/Core/Utils )
endif()


# Only install if the project name matches OpenMesh.
if (${CMAKE_PROJECT_NAME} MATCHES "OpenMesh")
  set (OPENMESH_NO_INSTALL_HEADERS FALSE CACHE BOOL "Should OpenMesh skip installing headers?")
else()
  set (OPENMESH_NO_INSTALL_HEADERS TRUE CACHE BOOL "Should OpenMesh skip installing headers?")
endif()

if (NOT APPLE AND NOT ${OPENMESH_NO_INSTALL_HEADERS})

# Install Header Files)
install(DIRECTORY . 
	DESTINATION include/OpenMesh/Core
        FILES_MATCHING 
	PATTERN "*.hh"
        PATTERN "CVS" EXCLUDE
        PATTERN ".svn" EXCLUDE
        PATTERN "tmp" EXCLUDE
	PATTERN "Templates" EXCLUDE
        PATTERN "Debian*" EXCLUDE)

#install the config file
install(FILES System/config.h DESTINATION include/OpenMesh/Core/System)

endif ()

install(TARGETS OpenMeshCore EXPORT OpenMeshConfig
  ARCHIVE DESTINATION ${VCI_PROJECT_LIBDIR}
  LIBRARY DESTINATION ${VCI_PROJECT_LIBDIR}
  RUNTIME DESTINATION ${VCI_PROJECT_BINDIR})

=== cmake-library/CI/tests/Gurobi/CMakeLists.txt ===
find_package(Gurobi REQUIRED)

add_executable(gurobi_c "gurobi_c.c")
target_link_libraries(gurobi_c Gurobi::GurobiC)
add_test(NAME gurobi_c COMMAND gurobi_c)

add_executable(gurobi_cxx "gurobi_cxx.cc")
target_link_libraries(gurobi_cxx Gurobi::GurobiCXX)
add_test(NAME gurobi_cxx COMMAND gurobi_cxx)

=== src/OpenMesh/Apps/Dualizer/CMakeLists.txt ===
include (VCICommon)

vci_add_executable (Dualizer dualizer.cc)

target_link_libraries (Dualizer
  OpenMeshCore
  OpenMeshTools
)

=== src/OpenMesh/Apps/ProgViewer/CMakeLists.txt ===
include (VCICommon)

set( headers
  ProgViewerWidget.hh
  ../QtViewer/QGLViewerWidget.hh
  ../QtViewer/MeshViewerWidgetT.hh
  ../QtViewer/MeshViewerWidgetT_impl.hh
)

set( sources
  ProgViewerWidget.cc
  progviewer.cc  
  ../QtViewer/QGLViewerWidget.cc
)

if (WIN32)
  vci_add_executable( ProgViewer WIN32 ${sources} ${headers})
else ()
  vci_add_executable( ProgViewer ${sources} ${headers})
endif ()

target_link_libraries ( ProgViewer
  OpenMeshCore
  OpenMeshTools
  ${QT_TARGET}::OpenGL
  ${QT_TARGET}::Widgets
  ${QT_TARGET}::Gui
  ${OPENGL_LIBRARIES}
)

if (QT_VERSION_MAJOR GREATER 5)
  target_link_libraries (ProgViewer ${QT_TARGET}::OpenGLWidgets)
endif()

=== src/OpenMesh/Apps/QtViewer/CMakeLists.txt ===
include (VCICommon)

set (sources
  MeshViewerWidget.cc
  QGLViewerWidget.cc
  meshviewer.cc
)

set (headers
  MeshViewerWidget.hh
  QGLViewerWidget.hh  
)

if (WIN32)
  vci_add_executable (QtViewer WIN32 ${sources} ${headers})
else ()
  vci_add_executable (QtViewer ${sources} ${headers})
endif ()

target_link_libraries (QtViewer
  OpenMeshCore
  OpenMeshTools
  ${QT_TARGET}::OpenGL
  ${QT_TARGET}::Widgets
  ${QT_TARGET}::Gui
  ${OPENGL_LIBRARIES}
)

if (QT_VERSION_MAJOR GREATER 5)
  target_link_libraries (QtViewer ${QT_TARGET}::OpenGLWidgets)
endif()

=== src/OpenMesh/Apps/Smoothing/CMakeLists.txt ===
include (VCICommon)

vci_add_executable (Smoothing smooth.cc)

target_link_libraries (Smoothing
  OpenMeshCore
  OpenMeshTools
)

=== src/OpenMesh/Apps/mconvert/CMakeLists.txt ===
include (VCICommon)

vci_add_executable (mconvert mconvert.cc)

target_link_libraries (mconvert
  OpenMeshCore
  OpenMeshTools
)

=== src/OpenMesh/Apps/Decimating/DecimaterGui/CMakeLists.txt ===
include (VCICommon)

set (headers
  ../DecimaterViewerWidget.hh
  ../../QtViewer/QGLViewerWidget.hh
  ../../QtViewer/MeshViewerWidgetT.hh
  ../../QtViewer/MeshViewerWidget.hh
  ../../QtViewer/MeshViewerWidgetT_impl.hh
)

set (sources
  ../../QtViewer/QGLViewerWidget.cc
  ../../QtViewer/MeshViewerWidget.cc
  ../DecimaterViewerWidget.cc
  ../decimaterviewer.cc
)

if (WIN32)
  vci_add_executable (DecimaterGui WIN32 ${sources} ${headers})
else ()
  vci_add_executable (DecimaterGui ${sources} ${headers} )
endif ()

target_link_libraries (DecimaterGui
  OpenMeshCore
  OpenMeshTools
  ${QT_TARGET}::OpenGL
  ${QT_TARGET}::Widgets
  ${QT_TARGET}::Gui
  ${OPENGL_LIBRARIES}
)

if (QT_VERSION_MAJOR GREATER 5)
  target_link_libraries (DecimaterGui ${QT_TARGET}::OpenGLWidgets)
endif()

=== debian/changelog ===
openmesh (11.0.0-2) unstable; urgency=medium

  * Team upload.
  * No change source-only upload for testing migration.

 -- Boyuan Yang <byang@debian.org>  Sat, 23 Nov 2024 18:24:26 -0500

openmesh (11.0.0-1) unstable; urgency=medium

  * New upstream release

 -- Dima Kogan <dkogan@debian.org>  Sun, 10 Nov 2024 20:53:37 -0800

=== debian/control ===
Source: openmesh
Section: libs
Priority: optional
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Dima Kogan <dkogan@debian.org>
Build-Depends: debhelper-compat (= 13),
               cmake,
               libopengl-dev,
               freeglut3-dev,
               libqt5opengl5-dev
Build-Depends-Indep: doxygen,
                     texlive-latex-base,
                     texlive-latex-extra,
                     graphviz,
                     ghostscript
Standards-Version: 4.6.0
Homepage: http://www.openmesh.org
Vcs-Git: https://salsa.debian.org/science-team/openmesh.git
Vcs-Browser: https://salsa.debian.org/science-team/openmesh

Package: libopenmesh11.0
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Tools for representing and manipulating polygonal meshes
 OpenMesh is a generic and efficient data structure for representing and
 manipulating polygonal meshes. It was designed with the following goals in
 mind:
 .
 - Flexibility: provide a basis for many different algorithms without the need
 for adaptation.
 .
 - Efficiency: maximize time efficiency while keeping memory usage as low as
 possible.
 .
 - Ease of use: wrap complex internal structure in an easy-to-use interface.
 .
 OpenMesh provides the following features:
 .
 - Representation of arbitrary polygonal (the general case) and pure triangle
 meshes (providing more efficient, specialized algorithms)
 .
 - Explicit representation of vertices, halfedges, edges and faces.
 .
 - Fast neighborhood access, especially the one-ring neighborhood
 .
 - Highly customizable
 .
   - Choose your coordinate type (dimension and scalar type)
   - Attach user-defined elements/functions to the mesh elements.
   - Attach and check for attributes
   - Attach data at runtime using dynamic properties.
 .
 This package provides the shared library

Package: libopenmesh-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}, libopenmesh11.0 (= ${binary:Version}),
         libeigen3-dev,
         libopenscenegraph-dev
Suggests: libopenmesh-doc, libopenmesh-apps
Description: Tools for representing and manipulating polygonal meshes
 OpenMesh is a generic and efficient data structure for representing and
 manipulating polygonal meshes. It was designed with the following goals in
 mind:
 .
 - Flexibility: provide a basis for many different algorithms without the need
 for adaptation.
 .
 - Efficiency: maximize time efficiency while keeping memory usage as low as
 possible.
 .
 - Ease of use: wrap complex internal structure in an easy-to-use interface.
 .
 OpenMesh provides the following features:
 .
 - Representation of arbitrary polygonal (the general case) and pure triangle
 meshes (providing more efficient, specialized algorithms)
 .
 - Explicit representation of vertices, halfedges, edges and faces.
 .
 - Fast neighborhood access, especially the one-ring neighborhood
 .
 - Highly customizable
 .
   - Choose your coordinate type (dimension and scalar type)
   - Attach user-defined elements/functions to the mesh elements.
   - Attach and check for attributes
   - Attach data at runtime using dynamic properties.
 .
 This package provides the development files library

Package: libopenmesh-apps
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libopenmesh11.0 (= ${binary:Version})
Description: Tools for representing and manipulating polygonal meshes
 OpenMesh is a generic and efficient data structure for representing and
 manipulating polygonal meshes. It was designed with the following goals in
 mind:
 .
 - Flexibility: provide a basis for many different algorithms without the need
 for adaptation.
 .
 - Efficiency: maximize time efficiency while keeping memory usage as low as
 possible.
 .
 - Ease of use: wrap complex internal structure in an easy-to-use interface.
 .
 OpenMesh provides the following features:
 .
 - Representation of arbitrary polygonal (the general case) and pure triangle
 meshes (providing more efficient, specialized algorithms)
 .
 - Explicit representation of vertices, halfedges, edges and faces.
 .
 - Fast neighborhood access, especially the one-ring neighborhood
 .
 - Highly customizable
 .
   - Choose your coordinate type (dimension and scalar type)
   - Attach user-defined elements/functions to the mesh elements.
   - Attach and check for attributes
   - Attach data at runtime using dynamic properties.
 .
 This package provides the executable tools

Package: libopenmesh-doc
Architecture: all
Depends: ${misc:Depends}
Section: doc
Suggests: libopenmesh-dev (= ${binary:Version}), libopenmesh-apps (= ${binary:Version})
Multi-Arch: foreign
Description: Tools for representing and manipulating polygonal meshes
 OpenMesh is a generic and efficient data structure for representing and
 manipulating polygonal meshes. It was designed with the following goals in
 mind:
 .
 - Flexibility: provide a basis for many different algorithms without the need
 for adaptation.
 .
 - Efficiency: maximize time efficiency while keeping memory usage as low as
 possible.
 .
 - Ease of use: wrap complex internal structure in an easy-to-use interface.
 .
 OpenMesh provides the following features:
 .
 - Representation of arbitrary polygonal (the general case) and pure triangle
 meshes (providing more efficient, specialized algorithms)
 .
 - Explicit representation of vertices, halfedges, edges and faces.
 .
 - Fast neighborhood access, especially the one-ring neighborhood
 .
 - Highly customizable
 .
   - Choose your coordinate type (dimension and scalar type)
   - Attach user-defined elements/functions to the mesh elements.
   - Attach and check for attributes
   - Attach data at runtime using dynamic properties.
 .
 This package provides the HTML documentation

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- \
		-DOPENMESH_DOCS=ON \
		-DBUILD_APPS=ON \
		-DOpenGL_GL_PREFERENCE=GLVND

override_dh_auto_build-arch:
	dh_auto_build -a

override_dh_auto_build-indep:
	$(MAKE) -C obj-$(DEB_HOST_GNU_TYPE) doc

override_dh_auto_test-indep:
	true

# I namespace all executables with "OpenMesh-"
# Their default names are just too generic
override_dh_auto_install-arch:
	dh_auto_install
	for f in debian/tmp/usr/bin/*; do mv $$f `dirname $$f`/OpenMesh-`basename $$f`; done

override_dh_auto_install-indep:
	true

=== debian/watch ===
version=4
https://www.graphics.rwth-aachen.de/software/openmesh/download/ \
.*/media/openmesh_static/Releases/(?:[0-9\.]*)/OpenMesh-(\d\S+)\.tar\.gz
